'Triple Output Power Supply Controller Rev 4D, for Picaxe 14M
'Fernando Garcia 04/2009
'Out0= Serout, Out1= SelA, Out2= SelB, Out3= Buzzer, Out4= Fan, Out5= Relay
'In0= Push button, In4= ADC
#picaxe 14m
symbol read_wrd = w0
symbol sum = w1
symbol volt_tenp = b12
symbol volt_intp = b4
symbol volt_decp = b5
symbol volt_cenp = b6
symbol volt_tenn = b13
symbol volt_intn = b7
symbol volt_decn = b8
symbol volt_cenn = b9
symbol cur_int = b4
symbol cur_dec = b5
symbol cur_cen = b6
symbol temphs = b10
setfreq m8

'read positive voltage 0,0
main:
low 1, 2				
gosub dataread
let volt_tenp = sum/30/100 	'calculate tens volts
let volt_intp = sum/300//10  	'calculate integer volts
let volt_decp = sum/30//10 	'calculate decimal volts
let volt_cenp = sum//30/3	'calculate hundrets volts

'read negative voltage 1,0
high 1 				
gosub dataread
let volt_tenn = sum/30/100	'calculate tens volts
let volt_intn = sum/300//10  	'calculate integer volts
let volt_decn = sum/30//10 	'calculate decimal volts
let volt_cenn = sum//30/3	'calculate hundrets volts
'display 1st line, positive and negative volts
serout 0,n1200, (254,128,"+",#volt_tenp,#volt_intp,".",#volt_decp,#volt_cenp,254,136,"-",#volt_tenn,#volt_intn,".",#volt_decn,#volt_cenn,"V")

'display 2nd line, options are: disabled, hi_current and actual current
'read current 1,1
high 2			
gosub dataread
readoutputs b11			'check output5 status
let b11 = b11 & %00100000 	'
if b11 = 0 then serout 0,n1200,(254,192, "disabled") 'display disabled condition if output low
goto temp_meas			'jump away from curr calculation
endif
if sum > 6126 then  		'if currinput > 1021 ADC counts, 3.063A
serout 0,n1200, (254,192,"hi_curr ") 'display high current condition
sound 3, (120, 50)		'beep
else
let cur_int = sum/2000		'else calculate integer amps
let cur_dec = sum/200//10	'calculate decimal amps
let cur_cen = sum//200/20	'calculate hundrets amps
serout 0,n1200, (254,192,"5V:",#cur_int, ".", #cur_dec,#cur_cen,"A") 'display actual current
endif

'read temp 0,1
temp_meas:
low 1				
gosub dataread
let temphs = sum/12		'calculate temp
if temphs > 151 then		'151F = 302ct		
high 4				'enble fan output4
endif
if temphs < 142 then		'142F = 284ct
low 4					'disable fan
endif

'check if button pressed?
button_loop:
if pin0 = 1 then
do until pin0 = 0			'wait for button release
pause 20
loop 
sound 3, (120, 20)		'beep
toggle 5				'toggle output5 state
endif 
goto main

'A/D subroutine
dataread:			
let sum = 0
for b11 = 1 to 6      		'read 6 times
readadc10 4, read_wrd
sum = sum + read_wrd		'accumulate in sum
next b11
return

























